package handler

import (
	"github.com/gin-gonic/gin"
	"github.com/sirupsen/logrus"
	"youngee_b_api/consts"
	"youngee_b_api/model/http_model"
	"youngee_b_api/service"
	"youngee_b_api/util"
)

func WrapLocalTaskDatalistHandler(ctx *gin.Context) {
	handler := newLocalTaskDatalistHandler(ctx)
	baseRun(handler)
}

type LocalTaskDatalist struct {
	ctx  *gin.Context
	req  *http_model.LocalTaskDatalistRequest
	resp *http_model.CommonResponse
}

func (c LocalTaskDatalist) getContext() *gin.Context {
	return c.ctx
}

func (c LocalTaskDatalist) getResponse() interface{} {
	return c.resp
}

func (c LocalTaskDatalist) getRequest() interface{} {
	return c.req
}

func (c LocalTaskDatalist) run() {
	data := http_model.LocalTaskDatalistRequest{}
	data = *c.req
	res, err := service.LocalTask.GetLocalTaskDatalist(c.ctx, data)
	if err != nil {
		logrus.Errorf("[GetLocalTaskDatalist] call GetLocalTaskDatalist err:%+v\n", err)
		util.HandlerPackErrorResp(c.resp, consts.ErrorParamCheck, "")
		logrus.Info("GetLocalTaskDatalist fail,req:%+v", c.req)
		return
	}
	c.resp.Message = "成功查询数据待审列表"
	c.resp.Data = res
	c.resp.Status = consts.ErrorSuccess
}

func (c LocalTaskDatalist) checkParam() error {
	return nil
}

func newLocalTaskDatalistHandler(ctx *gin.Context) *LocalTaskDatalist {
	return &LocalTaskDatalist{
		ctx:  ctx,
		req:  http_model.NewLocalTaskDatalistRequest(),
		resp: http_model.NewLocalTaskDatalistResponse(),
	}
}
